<?php
module_load_include('inc', 'bugbits', 'includes/mantisClient');

class mantisEnum {
  
  /**
   * Enumerate the different status
   *
   * @return a list of status
   */
  static function enumStatus(){
    $client = mantisClient::get();
    return $client->mc_enum_status($client->user, $client->pass);
  }
  
  /**
   * Enumerate the different priorities
   *
   * @return a list of priorities
   */
  static function enumPriorities(){
    $client = mantisClient::get();
    return $client->mc_enum_priorities($client->user, $client->pass);
  }
  
  /**
   * Enumerate the different severities
   *
   * @return a list of severities
   */
  static function enumSeverities(){
    $client = mantisClient::get();
    return $client->mc_enum_severities($client->user, $client->pass);
  }
  
  /**
   * Enumerate the different reproducibility steps
   *
   * @return a list of reproducibility steps
   */
  static function enumReproducibilities(){
    $client = mantisClient::get();
    return $client->mc_enum_reproducibilities($client->user, $client->pass);
  }
  
  /**
   * Enumerate the different projections
   *
   * @return a list of projections
   */
  static function enumProjections(){
    // ISSUE: are these even used?
    $client = mantisClient::get();
    return $client->mc_enum_projections($client->user, $client->pass);
  }
  
  /**
   * Enumerate the different ETA's
   *
   * @return a list of ETA's
   */
  static function enumEtas(){
    $client = mantisClient::get();
    return $client->mc_enum_etas($client->user, $client->pass);
  }
  
  /**
   * Enumerate the different resolutions
   *
   * @return a list of resolutions
   */
  static function enumResolutions(){
    $client = mantisClient::get();
    return $client->mc_enum_resolutions($client->user, $client->pass);
  }
  
  /**
   * Enumerate the different access levels
   *
   * @return a list of access levels
   */
  static function enumAccessLevels(){
    $client = mantisClient::get();
    return $client->mc_enum_access_levels($client->user, $client->pass);
  }
  
  /**
   * Enumerate the different project status
   *
   * @return a list of project status
   */
  static function enumProjectStatus(){
    $client = mantisClient::get();
    return $client->mc_enum_project_status($client->user, $client->pass);
  }
  
  /**
   * Enumerate the different project view states
   *
   * @return a list of project view states
   */
  static function enumProjectViewStates(){
    // ISSUE: what the hell is the difference with enum_view_states?
    $client = mantisClient::get();
    return $client->mc_enum_project_view_states($client->user, $client->pass);
  }
  
  /**
   * Enumerate the different view states
   *
   * @return a list of view states
   */
  static function enumViewStates(){
    $client = mantisClient::get();
    return $client->mc_enum_view_states($client->user, $client->pass);
  }
  
  /**
   * Enumerate the different custom field types
   *
   * @return a list of custom field types
   */
  static function enumCustomFieldTypes(){
    $client = mantisClient::get();
    return $client->mc_enum_custom_field_types($client->user, $client->pass);
  }
  
  /**
   * Enumerate the different ?
   *
   * @return a list of ?
   */
  static function enumGet($enumeration){
    // TODO: provide decent documentatinos for this function, is this for custom field types?
    $client = mantisClient::get();
    return $client->mc_enum_get($client->user, $client->pass, $enumeration);
  }
}
